rem HDR-Hyp2.bas by gehtnix, Hoelli und Werner_O 11.12.2011
@title HDR-Hyper-SX220
@param l CT 0=ja 1=aus 2=mEV
@default l 0
@param c EV Anzahl 3,5,7 => 1/2/3
@default c 1
@param p Blende prfen aus=0 ein=1
@default p 0
@param o do/until Sleep x10
@default o 0
@param x Zoom Sleep x10
@default x 50
@param z Tasten Sleep x10
@default z 15
@param f Zoomschritte fein
@default f 3

rem Stepweite Blendenreihe (32=1/3 EV)
if c=1 then H=192
if c=2 then H=96
if c=3 then H=64

t=get_zoom_steps
e=0  rem nullen Merker
g=0  rem grob Merker
j=2  rem RAW Merker 
u=0  rem Vorlauf Merker
o=o*10
x=x*10
z=z*10
cls

rem CT? einschalten sonst "Custom T ein" merken
if l=0 then gosub "customein" else a=2
sleep z

rem MF einschalten
h=4
gosub "schalten" 

rem Hyperfokus "Hyperfoc aus" merken
gosub "hyperfocal"
b=1

:start
  cls
  print "*** Zoom ist bereit ***"
  print "Halber Druck  =    Foto"
  if a=1 then print "Custom T aus  =     <<<"
  if a=2 then print "Custom T ein  =     <<<"
  if b=1 then print "Hyperfoc aus  =     >>>"
  if b=2 then print "Hyperfoc ein  =     >>>"
  print "Exit Alt      =     Set"

  wait_click
  k=is_pressed "zoom_in"
    if k=1 then click "zoom_in"
    if k=1 then sleep x
    if k=1 then gosub "hyperfocal"
  k=is_pressed "zoom_out"
    if k=1 then click "zoom_out"
    if k=1 then sleep x
    if k=1 then gosub "hyperfocal"
  k=is_pressed "left"
    if k=1 then gosub "custom"
    k=is_pressed "right"
    if k=1 then gosub "hyper"
  k=is_pressed "up"
    if k=1 then gosub "vorlauf"
  k=is_pressed "down"
    if k=1 then gosub "near"
  k=is_pressed "set"
    if k=1 then goto "restore"
  k=is_pressed "shoot_half"
    if k=1 then gosub "shoot"
  k=is_pressed "video"
    if k=1 then gosub "nullen"
  k=is_pressed "display"
    if k=1 then gosub "grob"
  k=is_pressed "menu"
    if k=1 then gosub "fein"
  goto "start"
  end

rem mEV Serie oder CT Aufnahme
:shoot
  if l=2 then
    gosub "serie"
  else
    sleep u
    shoot
  endif
  return

rem Einstellungen rcksetzen, Skript beenden
:restore
  set_led 4 0
  if a=1 then gosub "customaus"
  sleep z
  h=0 
  gosub "schalten"
  sleep z
  if j=1 then gosub "raw"
  cls
  exit_alt
  end

rem Hyperfokus aus/ein
:hyper
  if b=1 then
    h=0
    gosub "schalten"
    b=2
  else
    h=4
    gosub "schalten"
    gosub "hyperfocal"
    b=1
  endif
  return

rem Vorlauf max 3 Sek.
:vorlauf
  u=u+1000
  if u>3000 then u=0
  cls
  print ""
  print "Vorlauf auf "u/1000" Sek gesetzt"
  print ""
  sleep 1500
  return

rem Zoom max/min
:nullen
  if e=0 then
    set_zoom t-1
    e=1
  else
    gosub "zoomnull"
    e=0
  endif
  gosub "hyperfocal"
  return

rem Zoom grob 0-100% in 25% Schritten
:grob
  if g>100 then 
    gosub "zoomnull"
    g=0
  endif
  set_zoom t*g/100
  sleep x
  gosub "hyperfocal"
  g=g+25
  return

rem Zoom Schrittweise auf Null
rem direkt fhrt zu einem Objektivfehler
:zoomnull
    d=get_zoom
    for i=1 to 7
      set_zoom_rel -d/8
    next i
    set_zoom 0
  return

rem Zoom fein vor
:fein
  set_zoom_rel f
  gosub "hyperfocal"
  return

rem RAW ein/aus
:raw
  cls
  print ""
  if j=2 then
    set_raw 1
    print "***  RAW - EIN  ***"
    j=1
  else
    set_raw 0
    print "***  RAW - AUS  ***"
    j=2
  endif
  print ""
  sleep 750
  return

rem Motivprfung
:near
  cls
  rem AF einschalten
  h=0
  gosub "schalten"
  sleep z

  :neufok
  if get_nd_present=1 then set_aflock 0

  rem fokussieren und prfen
  press "shoot_half"
  do
    sleep o
  until get_shooting=1
  if get_focus_ok=1 then goto "sprung1"
  cls
  release "shoot_half"
  print "!!! Fokus nicht OK !!!"
  print "Kamera neu ausrichten"
  print "Ich wiederhole den Fokus"
  sleep 3000
  goto "neufok"

  rem Motiventfernung
  :sprung1
  S=get_focus
  release "shoot_half"
  do
    sleep o
  until get_shooting=0

  rem MF einschalten
  h=4
  gosub "schalten"
  sleep z

  rem Fokus auf hyperfokale Distanz
  set_focus A
  sleep 500
  if get_nd_present=1 then set_aflock 1

  rem Prfergebnisse anzeigen
  :wait2
  cls
  if S<N then
    playsound 3
    set_led 4 2
    print "* Motiv liegt vor NEAR *"
    print "*  Kamera nach hinten  *"
    O=(N%1000)/10
    if O<10 then O=O*10
    if N<10000 then
      print "NEAR        ",N/1000","O" m"
    else
      print "NEAR       ",N/1000","O" m"
    endif
  endif

  if S>A then
    print "*Motiv liegt hinter HYP*"
    print ""
  endif

  if S>=N and S<=A then
    print "> Motiv liegt zwischen <"
    print ">>>>  NEAR und HYP  <<<<"
    print ""
  endif

  O=(A%1000)/10
  if O<10 then O=O*10
  if A<10000 then
    print "Hyperfokal  ",A/1000","O" m  >>>"
  else
    print "Hyperfokal ",A/1000","O" m  >>>"
  endif

  O=(S%1000)/10
  if O<10 then O=O*10
  if S<10000 then
    print "Motiv bei   ",S/1000","O" m  <<<"
  else
    print "Motiv bei  ",S/1000","O" m  <<<"
  endif

  rem Auswahl: bernehmen, hyperfoc aus,
  rem RAW ein/aus, nochmal prfen, Skript beenden
  :wait
  wait_click
  k=is_pressed "right"
    if k=1 then goto "abgang"
  k=is_pressed "left"
    if k=1 then h=0
    if k=1 then gosub "hyper"
    if k=1 then goto "abgang"
  k=is_pressed "up"
    if k=1 then set_led 4 0
    if k=1 then goto "near"
  k=is_pressed "down"
    if k=1 then gosub "raw"
    if k=1 then goto "wait2"
  k=is_pressed "set"
    if k=1 then goto "restore"
  goto "wait"

  :abgang
  set_led 4 0
  cls
  return

rem mEV Belichtungsreihe 2 Sek. Vorlauf
:serie
  sleep 2000
  for i=-192 to 192 step H
    set_ev i
    shoot
  next i
  set_ev 0
  return 

rem Fokus auf hyperfokale Distanz
:hyperfocal
  if get_nd_present=1 then set_aflock 0
  
  rem ohne Blendenprfung
  if p=0 then
    A=get_hyp_dist
    set_focus A
  
  rem mit Blendenprfung
  else
    press "shoot_half"
    do
      sleep o
    until get_shooting=1
    A=get_hyp_dist
    release "shoot_half"
    do
      sleep o
    until get_shooting=0
    set_focus A
  endif
  sleep x

  rem Nahlimit merken
  N=get_near_limit
  if get_nd_present=1 then set_aflock 1
  return

rem MF/AF-Umschaltung
:schalten
  if get_nd_present=1 then goto "ixus"
  cls
  F=get_prop 6 rem focusmode
  click "left"
  sleep z
  if h=F then goto "setzen"
  if h=0 and F=1 then goto "rechts"
  if h=1 and F=4 then goto "rechts"
  if h=4 and F=0 then goto "rechts"
  if h=0 and F=4 then goto "links"
  if h=1 and F=0 then goto "links"
  if h=4 and F=1 then goto "links"
  :rechts
    click "right"
    sleep z
    goto "setzen"
  :links
    click "left"
    sleep z
  :setzen
    click "set"
    sleep z
  return

rem CT ein/aus
:custom
  if a=1 then 
    gosub "customaus"
  else
    gosub "customein"
  endif
  return

:customein
  click "down"
  sleep z
  click "up"
  sleep z
  click "set"
  sleep z
  a=1
  return

:customaus
  click "down"
  sleep z
  click "down"
  sleep z
  click "set"
  sleep z
  a=2
  return
